/**************************************************************************
* DSemu: Interrupt triggering and flag clear (int.c)                      *
* Released under the terms of the BSD Public Licence                      *
* Imran Nazar (tf@oopsilon.com), 2004                                     *
**************************************************************************/

#include "defs.h"
#include "int.h"
#include "arm7.h"
#include "ioreg.h"

u16 intFired=0;

void IntFire(u16 interrupt)
{
    if(GBAio[REG_IME].data)
    {
	if(GBAio[REG_IE].data&interrupt)
	{
	    GBAio[REG_IF].data|=interrupt;
	    intFired=interrupt;
	    ARM7irq();
	}
    }
}

void IntClear(u16 interrupt)
{
    GBAio[REG_IF].data&=(0xFFFF-interrupt);
}

/*** EOF:int.c ***********************************************************/

