/**************************************************************************
* DSemu: VTable structure definitions (vtbl.h)                            *
* Released under the terms of the BSD Public Licence                      *
* Imran Nazar (tf@oopsilon.com), 2004                                     *
**************************************************************************/

#ifndef __VTBL_H_
#define __VTBL_H_

#include <windows.h>
#include "defs.h"
#include "emu.h"

typedef struct {
    void (*init)();
    void (*fini)();
    void (*append)(char*);
    char *file;
} LOGVTBL;

extern LOGVTBL *logvt;

typedef struct {
    int (*init)(char*,LOGVTBL*,HWND,HWND,HWND,HWND);
    void (*fini)();
    int (*reset)();
    void (*keyin)(u32,int);
    void (*frame)();
    void (*line)();
    void (*step)();
    void (*refresh)();
    void (*cpudbg)(int,int);
    void (*mmudump)(u32,int);
    void (*gpucol)(int);
    int running;
    int animate;
    int fixfps;
    int gpuon;
} EMUVTBL;

#endif//__VTBL_H_

/*** EOF:vtbl.h **********************************************************/

